## cpu-x 3.1.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(LOCALVERSION "3.1.3")
if(${CMAKE_VERSION} VERSION_GREATER "2.9")
	cmake_policy(SET CMP0048 NEW)
	project(cpu-x
		VERSION ${LOCALVERSION}
		LANGUAGES C
	)
else(${CMAKE_VERSION} VERSION_GREATER "2.9")
	project(cpu-x)
	set(PROJECT_VERSION ${LOCALVERSION})
endif(${CMAKE_VERSION} VERSION_GREATER "2.9")


### DEFAULT CONFIG

# Global variables
if(PORTABLE_BINARY)
	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
else(PORTABLE_BINARY)
	include(GNUInstallDirs)
	set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/output/bin/)
	set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/output/lib/)
	set(CMAKE_DATA_OUTPUT_DIRECTORY    ${CMAKE_BINARY_DIR}/output/data/)
	set(CPU_X_DATA_DIRECTORY           ${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}/)
endif(PORTABLE_BINARY)
if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "i.86")
	set(BITNESS "32")
else(${CMAKE_SYSTEM_PROCESSOR} MATCHES "i.86")
	set(BITNESS "64")
endif(${CMAKE_SYSTEM_PROCESSOR} MATCHES "i.86")
set(CPU_X_FLAGS           "-Wno-unused-parameter -Wno-unused-result -Wno-format-security")
set(CPU_X_DEBUG_FLAGS     "-Wall -Wextra -Wuninitialized -Wstrict-prototypes ${CPU_X_FLAGS}")
set(CMAKE_C_FLAGS         "${CMAKE_C_FLAGS} -Wno-deprecated-declarations ${CPU_X_FLAGS}")
set(CMAKE_C_FLAGS_DEBUG   "${CMAKE_C_FLAGS_DEBUG}   ${CPU_X_DEBUG_FLAGS}")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${CPU_X_DEBUG_FLAGS}")

# Options
option(WITH_GTK           "Build support for GUI in GTK3+"                                    ON)
option(WITH_NCURSES       "Build support for TUI in NCurses"                                  ON)
option(WITH_GETTEXT       "Build support for internationalization"                            ON)
option(WITH_LIBCURL       "Use Libcurl library"                                               ON)
option(WITH_LIBCPUID      "Use Libcpuid library"                                              ON)
option(WITH_LIBPCI        "Use Libpci library"                                                ON)
option(WITH_LIBPROCPS     "Use Libprocps library"                                             ON)
option(WITH_LIBSTATGRAB   "Use Libstatgrab library"                                           ON)
option(WITH_DMIDECODE     "Built-in Dmidecode"                                                ON)
option(WITH_BANDWIDTH     "Built-in Bandwidth"                                                ON)
option(FORCE_LIBSTATGRAB  "Force use of Libstatgrab instead of Libprocps (GNU/Linux system)"  OFF)
option(PORTABLE_BINARY    "Build a all-in-one binary (portable version)"                      OFF)
option(IGNORE_STATICLIBS  "Build portable binary without static libraries"                    OFF)

# Colours
string(ASCII 27 Esc)
set(ColourReset "${Esc}[m")
set(ColourBold  "${Esc}[1m")
set(Red         "${Esc}[31m")
set(Green       "${Esc}[32m")
set(Yellow      "${Esc}[33m")
set(Blue        "${Esc}[34m")
set(Magenta     "${Esc}[35m")
set(Cyan        "${Esc}[36m")
set(White       "${Esc}[37m")
set(BoldRed     "${Esc}[1;31m")
set(BoldGreen   "${Esc}[1;32m")
set(BoldYellow  "${Esc}[1;33m")
set(BoldBlue    "${Esc}[1;34m")
set(BoldMagenta "${Esc}[1;35m")
set(BoldCyan    "${Esc}[1;36m")
set(BoldWhite   "${Esc}[1;37m")


### MACROS

# Macro: print_config(libname foundstate withstate)
# Print the state of CPU-X features: in bold green if enabled, else bold red.
# @libname:    library name (e.g. GTK)
# @libver:     library version (e.g. XXXXX_VERSION)
# @foundstate: the result of pkg_check_modules(...) (e.g. XXXXX_FOUND)
# @withstate:  the CMake option which allows to disable this feature (e.g. WITH_XXXXX)
macro(print_config libname libver foundstate withstate)
	if(${foundstate} AND ${withstate})
		message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldGreen}enabled${ColourReset}")
		add_definitions(-DHAS_${libname}=1 -D${libname}_VERSION="${libver}")
	else(${foundstate} AND ${withstate})
		if(NOT ${withstate})
			message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset} (explicitly disabled)")
		elseif(NOT ${foundstate})
			message("${BoldCyan}**   ${libname}${ColourReset}\tsupport is ${BoldRed}disabled${ColourReset} (not found by pkg-config)")
		endif()
		add_definitions(-DHAS_${libname}=0 -D${libname}_VERSION=NULL)
	endif(${foundstate} AND ${withstate})
endmacro(print_config)

# Macro: add_embedded_library(lib)
# Include a library (satic or not) for building, needed for portable version.
# @LIBRARIES: variable name where to put libraries name
# @lib:	      library to add
macro(add_embedded_library LIBRARIES lib)
	if(PORTABLE_BINARY AND NOT IGNORE_STATICLIBS)
		set(${LIBRARIES} ${lib})
	endif(PORTABLE_BINARY AND NOT IGNORE_STATICLIBS)
endmacro(add_embedded_library)

# Macro: add_embedded_library_linux(linux_lib)
# Same as add_embedded_library macro, but only if target is Linux
# @LIBRARIES: variable name where to put libraries name
# @linux_lib: Linux library to add
macro(add_embedded_library_linux LIBRARIES linux_lib)
	if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND PORTABLE_BINARY AND NOT IGNORE_STATICLIBS)
		set(${LIBRARIES} ${linux_lib})
	endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND PORTABLE_BINARY AND NOT IGNORE_STATICLIBS)
endmacro(add_embedded_library_linux)

# Macro: add_embedded_library_others(others_lib)
# Same as add_embedded_library macro, but only if target is NOT Linux
# @LIBRARIES:  variable name where to put libraries name
# @others_lib: NON-Linux library name
macro(add_embedded_library_others LIBRARIES others_lib)
	if(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND PORTABLE_BINARY AND NOT IGNORE_STATICLIBS)
		set(${LIBRARIES} ${others_lib})
	endif(NOT ${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND PORTABLE_BINARY AND NOT IGNORE_STATICLIBS)
endmacro(add_embedded_library_others)


### HELPERS / SUBDIRECTORIES

find_package(PkgConfig REQUIRED)
find_package(Gettext)
find_package(Intl)
find_package(Threads)
find_package(Backtrace)
add_subdirectory(po)
add_subdirectory(src)
add_subdirectory(data)


### UNINSTALL TARGET

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY
)

add_custom_target(uninstall
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

=== data/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
if(${CMAKE_VERSION} VERSION_GREATER "2.9")
	cmake_policy(SET CMP0048 OLD)
endif(${CMAKE_VERSION} VERSION_GREATER "2.9")
project(data)


# Files needed by GTK GUI
if(WITH_GTK AND NOT PORTABLE_BINARY)
	# Set config
	file(MAKE_DIRECTORY ${CMAKE_DATA_OUTPUT_DIRECTORY})
	set(EXEC    ${CMAKE_INSTALL_FULL_BINDIR}/${CMAKE_PROJECT_NAME})
	set(TRYEXEC ${EXEC})
	configure_file(cpu-x.desktop.in           ${CMAKE_DATA_OUTPUT_DIRECTORY}/cpu-x.desktop)
	configure_file(org.pkexec.cpu-x.policy.in ${CMAKE_DATA_OUTPUT_DIRECTORY}/org.pkexec.cpu-x.policy)
	configure_file(cpu-x_polkit.in            ${CMAKE_DATA_OUTPUT_DIRECTORY}/cpu-x_polkit)

	set(EXEC ${EXEC}_polkit)
	configure_file(cpu-x-root.desktop.in ${CMAKE_DATA_OUTPUT_DIRECTORY}/cpu-x-root.desktop)

	# Install UIs
	install(FILES
		cpu-x-gtk-3.12.ui
		cpu-x-gtk-3.12.css
		cpu-x-gtk-3.20.css
		DESTINATION ${CPU_X_DATA_DIRECTORY}/
	)

	# Install launchers
	install(FILES
		${CMAKE_DATA_OUTPUT_DIRECTORY}/cpu-x.desktop
		${CMAKE_DATA_OUTPUT_DIRECTORY}/cpu-x-root.desktop
		DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/applications/
	)

	# Install policy rule
	install(FILES
		${CMAKE_DATA_OUTPUT_DIRECTORY}/org.pkexec.cpu-x.policy
		DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/polkit-1/actions/
	)

	# Install binary which can run CPU-X as root via Polkit
	install(FILES
		${CMAKE_DATA_OUTPUT_DIRECTORY}/cpu-x_polkit
		DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}/
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
	)

	add_subdirectory(icons)
	add_subdirectory(logos)
endif(WITH_GTK AND NOT PORTABLE_BINARY)

=== po/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
if(${CMAKE_VERSION} VERSION_GREATER "2.9")
	cmake_policy(SET CMP0048 OLD)
endif(${CMAKE_VERSION} VERSION_GREATER "2.9")
project(po)

# Config (po)
set(absPotFile "${CMAKE_SOURCE_DIR}/po/cpu-x.pot")
FILE(GLOB absPoFiles ${CMAKE_SOURCE_DIR}/po/*.po)


### INTERNATIONALIZATION TARGETS

if(GETTEXT_FOUND)
	# Target: genpot
	# Generate a new cpu-x.pot file
	set(GETTEXT_FOUND ON PARENT_SCOPE)
	add_custom_target(genpot
		COMMAND xgettext
			--language=C
			--package-name=${CMAKE_PROJECT_NAME}
			--package-version=${PROJECT_VERSION}
			--default-domain=${CMAKE_PROJECT_NAME}
			--msgid-bugs-address=https://github.com/X0rg/CPU-X/issues
			--copyright-holder=Xorg
			--output-dir=${CMAKE_SOURCE_DIR}/po
			--output=${CMAKE_PROJECT_NAME}.pot
			--keyword=_ --keyword=N_ --indent
			--directory="../src"
			"*.c"
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/src
	)

	# Target: newpo
	# Start a new translation (new file is NEW_TRANSLATION.po)
	add_custom_target(newpo
		COMMAND ${CMAKE_COMMAND} -E copy ${absPotFile} NEW_TRANSLATION.po
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/po
	)

	# Target: updatepo
	# Update existing translations by merging new strings from .pot file
	add_custom_target(updatepo)
	set(results)
	foreach(absPoFile ${absPoFiles})
		add_custom_command(TARGET updatepo
			COMMAND ${GETTEXT_MSGMERGE_EXECUTABLE} --quiet --indent --update --backup=existing ${absPoFile} ${absPotFile}
			COMMENT "Update po file ${absPoFile}"
		)
		set(results ${results} ${absPoFile})
	endforeach(absPoFile)
	add_custom_command(TARGET updatepo
		DEPENDS ${results}
	)

	# Target: potfiles_1
	# Convert .po files to .mo binary files and install them
	file(COPY ${absPoFiles} DESTINATION ${CMAKE_CURRENT_BINARY_DIR})
	foreach(absPoFile ${absPoFiles})
		get_filename_component(poFile ${absPoFile} NAME)
		string(REGEX REPLACE "^(.+)(\\.[^.]+)$" "\\1" poFile ${poFile})
		set(poFiles ${poFiles} ${poFile})
	endforeach(absPoFile)
	GETTEXT_PROCESS_POT_FILE(${absPotFile}
		ALL
		INSTALL_DESTINATION "${CMAKE_INSTALL_PREFIX}/share/locale"
		LANGUAGES ${poFiles}
	)
	add_custom_command(TARGET potfiles_1
		DEPENDS ${poFiles}
	)

	if(PORTABLE_BINARY)
		# Target: convertgmo
		# Convert .gmo files in a C header file
		add_custom_target(convertgmo ALL)
		set(vars)
		set(moHeader "${CMAKE_SOURCE_DIR}/po/mo.h")
		add_custom_command(TARGET convertgmo
			COMMAND ${CMAKE_COMMAND} -E remove ${moHeader}
		)
		foreach(poFile ${poFiles})
			add_custom_command(TARGET convertgmo
				COMMAND xxd -i "${poFile}.gmo" >> ${moHeader}
				WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
				COMMENT "Convert file ${poFile}.gmo in header"
				DEPENDS ${poFiles}
			)
			set(vars ${vars} "${poFile}_gmo")
		endforeach(poFile)

		# Add variables 'lang', 'ptrlang' and 'ptrlen' in header
		set(lang	'char *lang[] = { ')
		set(ptrlang	'unsigned char *ptrlang[] = { ')
		set(ptrlen	'unsigned int *ptrlen[] = { ')
		foreach(poFile ${poFiles})
			set(lang	${lang}		'\"${poFile}\", ')
			set(ptrlang	${ptrlang}	'${poFile}_gmo, ')
			set(ptrlen	${ptrlen}	'&${poFile}_gmo_len, ')
		endforeach(poFile)
		set(lang	${lang}		'\"\" }\\\;')
		set(ptrlang	${ptrlang}	'NULL }\\\;')
		set(ptrlen	${ptrlen}	'NULL }\\\;')
		add_custom_command(TARGET convertgmo
			COMMAND ${CMAKE_COMMAND} -E echo ${lang} >> ${moHeader}
			COMMAND ${CMAKE_COMMAND} -E echo ${ptrlang} >> ${moHeader}
			COMMAND ${CMAKE_COMMAND} -E echo ${ptrlen} >> ${moHeader}
			DEPENDS ${lang} ${ptrlang} ${ptrlen})
		add_dependencies(convertgmo potfiles)
	endif(PORTABLE_BINARY)

else(GETTEXT_FOUND)
	set(GETTEXT_FOUND OFF PARENT_SCOPE)
endif(GETTEXT_FOUND)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
if(${CMAKE_VERSION} VERSION_GREATER "2.9")
	cmake_policy(SET CMP0048 OLD)
endif(${CMAKE_VERSION} VERSION_GREATER "2.9")
project(binary)


### FIND NEEDED LIBRAIRIES

# GTK3+
if(WITH_GTK)
	set(MINIMUM_GTK_VERSION 3.12.0)
	pkg_check_modules(GTK3 gtk+-3.0>=${MINIMUM_GTK_VERSION})
	if(GTK3_FOUND)
		include_directories(${GTK3_INCLUDE_DIRS})
		link_directories(${GTK3_LIBRARY_DIRS})
		add_definitions(${GTK3_CFLAGS_OTHER})
		if(PORTABLE_BINARY)
			execute_process(COMMAND glib-compile-resources --target=${CMAKE_SOURCE_DIR}/src/gtk-resources.c --generate-source cpu-x.gresource.xml
					COMMAND	glib-compile-resources --target=${CMAKE_SOURCE_DIR}/src/gtk-resources.h --generate-header cpu-x.gresource.xml
					WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/data
			)
			set(GRESOURCES "gtk-resources.c")
		endif(PORTABLE_BINARY)
		add_library(gui_gtk
			gui_gtk.c
			gui_gtk.h
			gui_gtk_id.h
			${GRESOURCES}
		)
		set(GTK3_LIBRARIES "gui_gtk" ${GTK3_LIBRARIES})
	else(GTK3_FOUND)
		message("${BoldYellow}GTK3+ GUI will not be build:${ColourReset} ${Yellow}GTK ${MINIMUM_GTK_VERSION} or higher is needed.${ColourReset}")
		message("${Yellow}Set ${BoldYellow}PKG_CONFIG_PATH${ColourReset}${Yellow} environment variable if development files are installed.${ColourReset}")
	endif(GTK3_FOUND)
endif(WITH_GTK)

# NCurses
if(WITH_NCURSES)
	pkg_check_modules(NCURSES ncurses)
	if(NCURSES_FOUND)
		include_directories(${NCURSES_INCLUDE_DIRS})
		link_directories(${NCURSES_LIBRARY_DIRS})
		add_library(tui_ncurses
			tui_ncurses.c
			tui_ncurses.h
		)
		add_embedded_library(NCURSES_LIBRARIES "-l:libncursesw.a")
		add_embedded_library_others(NCURSES_LIBRARIES "${NCURSES_LIBRARIES} -l:libtinfo.a")
		set(NCURSES_LIBRARIES "tui_ncurses" ${NCURSES_LIBRARIES})
	endif(NCURSES_FOUND)
endif(WITH_NCURSES)

# Gettext
if(Intl_FOUND)
	add_embedded_library_others(Intl_LIBRARIES "-l:libintl.a")
endif(Intl_FOUND)

# Libcurl
if(WITH_LIBCURL)
	pkg_check_modules(LIBCURL libcurl)
	if(LIBCURL_FOUND)
		include_directories(${LIBCURL_INCLUDE_DIRS})
		link_directories(${LIBCURL_LIBRARY_DIRS})
		add_definitions(${LIBCURL_CFLAGS_OTHER})
		add_embedded_library(LIBCURL_LIBRARIES "-l:libcurl.a")
		add_embedded_library_linux(LIBCURL_LIBRARIES "${LIBCURL_LIBRARIES} -l:libssl.a -l:libcrypto.a -lz -ldl")
	endif(LIBCURL_FOUND)
endif(WITH_LIBCURL)

# Libarchive
if(PORTABLE_BINARY)
	pkg_check_modules(LIBARCHIVE libarchive REQUIRED)
	if(LIBARCHIVE_FOUND)
		include_directories(${LIBARCHIVE_INCLUDE_DIRS})
		link_directories(${LIBARCHIVE_LIBRARY_DIRS})
		add_definitions(${LIBARCHIVE_CFLAGS_OTHER})
		add_embedded_library(LIBARCHIVE_LIBRARIES "-l:libarchive.a")
		add_embedded_library_others(LIBARCHIVE_LIBRARIES "${LIBARCHIVE_LIBRARIES} -l:libssl.a -l:libcrypto.a -l:libgssapi.a -l:libbz2.a")
	endif(LIBARCHIVE_FOUND)
endif(PORTABLE_BINARY)

# Libcpuid
if(WITH_LIBCPUID)
	pkg_check_modules(LIBCPUID libcpuid>=0.3.0)
	if(LIBCPUID_FOUND)
		include_directories(${LIBCPUID_INCLUDE_DIRS})
		link_directories(${LIBCPUID_LIBRARY_DIRS})
		add_definitions(${LIBCPUID_CFLAGS_OTHER})
		add_embedded_library(LIBCPUID_LIBRARIES "-l:libcpuid.a")
	endif(LIBCPUID_FOUND)
endif(WITH_LIBCPUID)

# Libpci
if(WITH_LIBPCI)
	pkg_check_modules(LIBPCI libpci)
	if(LIBPCI_FOUND)
		include_directories(${LIBPCI_INCLUDE_DIRS})
		link_directories(${LIBPCI_LIBRARY_DIRS})
		add_definitions(${LIBPCI_CFLAGS_OTHER})
		add_embedded_library(LIBPCI_LIBRARIES "-l:libpci.a")
		add_embedded_library_linux(LIBPCI_LIBRARIES "${LIBPCI_LIBRARIES} -lresolv -ludev")
		add_embedded_library_others(LIBPCI_LIBRARIES "${LIBPCI_LIBRARIES} -lz")
	endif(LIBPCI_FOUND)
endif(WITH_LIBPCI)

# Libprocps
set(LIBSYSTEM 0)
if(WITH_LIBPROCPS AND ${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
	pkg_check_modules(LIBPROCPS libprocps)
	if(LIBPROCPS_FOUND)
		include_directories(${LIBPROCPS_INCLUDE_DIRS})
		link_directories(${LIBPROCPS_LIBRARY_DIRS})
		add_definitions(${LIBPROCPS_CFLAGS_OTHER})
		add_embedded_library(LIBPROCPS_LIBRARIES "-l:libprocps.a")
		set(LIBSYSTEM 1)
	endif(LIBPROCPS_FOUND)
endif(WITH_LIBPROCPS AND ${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)

# Libstatgrab
if(WITH_LIBSTATGRAB AND (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR FORCE_LIBSTATGRAB))
	pkg_check_modules(LIBSTATGRAB libstatgrab)
	if(LIBSTATGRAB_FOUND)
		include_directories(${LIBSTATGRAB_INCLUDE_DIRS})
		link_directories(${LIBSTATGRAB_LIBRARY_DIRS})
		add_definitions(${LIBSTATGRAB_CFLAGS_OTHER})
		add_embedded_library(LIBSTATGRAB_LIBRARIES "-l:libstatgrab.a")
		add_embedded_library_others(LIBSTATGRAB_LIBRARIES "${LIBSTATGRAB_LIBRARIES} -l:libdevstat.a -l:libkvm.a")
		set(LIBSYSTEM 2)
	endif(LIBSTATGRAB_FOUND)
endif(WITH_LIBSTATGRAB AND (NOT ${CMAKE_SYSTEM_NAME} MATCHES "Linux" OR FORCE_LIBSTATGRAB))

# Dmidecode
if(WITH_DMIDECODE)
	add_subdirectory(dmidecode)
	include_directories(dmidecode)
	set(DMIDECODE_LIBRARIES "dmidecode")
endif(WITH_DMIDECODE)

# Bandwidth
if(WITH_BANDWIDTH)
	add_subdirectory(bandwidth)
	if(BANDWIDTH_FOUND)
		include_directories(bandwidth)
		set(BANDWIDTH_LIBRARIES "bandwidth")
	endif(BANDWIDTH_FOUND)
endif(WITH_BANDWIDTH)


### FINAL CONFIG

message("${BoldCyan}** ${CMAKE_PROJECT_NAME} ${PROJECT_VERSION} configuration **${ColourReset}")

# UI libraries
print_config("GTK"                 "${GTK3_VERSION}"        GTK3_FOUND        WITH_GTK)
print_config("NCURSES"             "${NCURSES_VERSION}"     NCURSES_FOUND     WITH_NCURSES)

# Other libraries
print_config("GETTEXT"             0                        GETTEXT_FOUND     WITH_GETTEXT)
print_config("LIBCURL"             "${LIBCURL_VERSION}"     LIBCURL_FOUND     WITH_LIBCURL)
print_config("LIBCPUID"            "${LIBCPUID_VERSION}"    LIBCPUID_FOUND    WITH_LIBCPUID)
print_config("LIBPCI"              "${LIBPCI_VERSION}"      LIBPCI_FOUND      WITH_LIBPCI)
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
	print_config("LIBPROCPS"   "${LIBPROCPS_VERSION}"   LIBPROCPS_FOUND   WITH_LIBPROCPS)
else()
	print_config("LIBSTATGRAB" "${LIBSTATGRAB_VERSION}" LIBSTATGRAB_FOUND WITH_LIBSTATGRAB)
endif()

# Subprojects
print_config("DMIDECODE"           "${DMIDECODE_VERSION}"   1                 WITH_DMIDECODE)
print_config("BANDWIDTH"           "${BANDWIDTH_VERSION}"   BANDWIDTH_FOUND   WITH_BANDWIDTH)


### MAIN BINARY

# Executable
add_executable(cpu-x
	main.c
	util.c
	cpu-x.h
	core.c
	core.h
)

# Portable binary & Gettext stuff
if(PORTABLE_BINARY)
	message("${BoldBlue}${CMAKE_PROJECT_NAME} will be compiled as portable binary.${ColourReset}")
	add_definitions(-DPORTABLE_BINARY=1)
	find_path(XXD xxd)
	if(NOT XXD)
		message(FATAL_ERROR "${BoldRed}'xxd' command not found, can't perform build!${ColourReset}")
	endif(NOT XXD)
	if(WITH_GETTEXT)
		set(CMAKE_INSTALL_FULL_LOCALEDIR "/tmp/.cpu-x")
		add_dependencies(cpu-x convertgmo)
	endif(WITH_GETTEXT)
else(PORTABLE_BINARY)
	add_definitions(-DPORTABLE_BINARY=0)
	if(GETTEXT_FOUND)
		add_dependencies(cpu-x potfiles)
	endif(GETTEXT_FOUND)
endif(PORTABLE_BINARY)

# OS macro definition
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
	add_definitions(-DOS="linux${BITNESS}")
elseif(${CMAKE_SYSTEM_NAME} MATCHES FreeBSD OR ${CMAKE_SYSTEM_NAME} MATCHES DragonFly)
	add_definitions(-DOS="bsd${BITNESS}")
else()
	message("${BoldYellow}Unknown operating system: ${CMAKE_SYSTEM_NAME}${ColourReset}")
	add_definitions(-DOS="unknown${BITNESS}")
endif()

# Libsystem extra-definitions
if(${LIBSYSTEM} EQUAL 0 OR ${LIBSYSTEM} EQUAL 1)
	add_definitions(-DHAS_LIBSTATGRAB=0 -DLIBSTATGRAB_VERSION=NULL)
endif()
if(${LIBSYSTEM} EQUAL 0 OR ${LIBSYSTEM} EQUAL 2)
	add_definitions(-DHAS_LIBPROCPS=0   -DLIBPROCPS_VERSION=NULL)
endif()

# Various definitions
add_definitions(-DPRGVER="${PROJECT_VERSION}" -DCC="${CMAKE_C_COMPILER_ID}" -DHAS_LIBSYSTEM="${LIBSYSTEM}")
add_definitions(-DGETTEXT_PACKAGE="${CMAKE_PROJECT_NAME}" -DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}")

# Link libraries
target_link_libraries(cpu-x
	m
	${Intl_LIBRARIES}
	${CMAKE_THREAD_LIBS_INIT}
	${Backtrace_LIBRARIES}

	${GTK3_LIBRARIES}
	${NCURSES_LIBRARIES}
	${LIBCURL_LIBRARIES}
	${LIBARCHIVE_LIBRARIES}
	${LIBCPUID_LIBRARIES}
	${LIBPCI_LIBRARIES}
	${LIBPROCPS_LIBRARIES}
	${LIBSTATGRAB_LIBRARIES}
	${DMIDECODE_LIBRARIES}
	${BANDWIDTH_LIBRARIES}
)


### INSTALLATION

install(TARGETS cpu-x DESTINATION ${CMAKE_INSTALL_FULL_BINDIR}/)

=== data/icons/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
if(${CMAKE_VERSION} VERSION_GREATER "2.9")
	cmake_policy(SET CMP0048 OLD)
endif(${CMAKE_VERSION} VERSION_GREATER "2.9")
project(icons)


# Icons
file(GLOB
	icons
	CPU-X_*x*.png
)

foreach(icon ${icons})
	get_filename_component(filename ${icon} NAME_WE)
	string(REGEX REPLACE "CPU-X_" "" size "${filename}")
	install(FILES
		${icon}
		DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/${size}/apps/
		RENAME cpu-x.png
	)
endforeach()

install(FILES
	CPU-X_original.png
	DESTINATION ${CPU_X_DATA_DIRECTORY}/
	RENAME CPU-X.png
)

=== data/logos/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
if(${CMAKE_VERSION} VERSION_GREATER "2.9")
	cmake_policy(SET CMP0048 OLD)
endif(${CMAKE_VERSION} VERSION_GREATER "2.9")
project(logos)


# Logos
install(FILES
	AMD.png
	Centaur.png
	Cyrix.png
	Intel.png
	NexGen.png
	NSC.png
	Rise.png
	SiS.png
	Transmeta.png
	UMC.png
	Unknown.png
	DESTINATION ${CPU_X_DATA_DIRECTORY}/
)

=== src/bandwidth/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(LOCALVERSION "1.3.1")
if(${CMAKE_VERSION} VERSION_GREATER "2.9")
	cmake_policy(SET CMP0048 NEW)
	project(bandwidth
		VERSION ${LOCALVERSION}
		LANGUAGES C
	)
else(${CMAKE_VERSION} VERSION_GREATER "2.9")
	project(bandwidth)
	set(PROJECT_VERSION ${LOCALVERSION})
endif(${CMAKE_VERSION} VERSION_GREATER "2.9")

# Config (bandwidth)
set(BANDWIDTH_DEBUG_FLAGS "-Wall -Wextra -Wuninitialized -Wno-strict-prototypes -Wno-unused-parameter -Wno-sign-compare -Wno-format-security")
set(CMAKE_C_FLAGS_DEBUG	  "${CMAKE_C_FLAGS_DEBUG}   ${BANDWIDTH_DEBUG_FLAGS}")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${BANDWIDTH_DEBUG_FLAGS}")

find_program(NASM_FOUND nasm)
if(NASM_FOUND)
	enable_language(ASM_NASM)
endif(NASM_FOUND)

# Build (bandwidth)
if(CMAKE_ASM_NASM_INFOMATION_LOADED)
	set(BANDWIDTH_FOUND ON PARENT_SCOPE)
	message(STATUS "Using built-in ${PROJECT_NAME}, version ${PROJECT_VERSION}")

	if(BITNESS EQUAL 32)
		set(ROUTINES "routines-x86-32bit")
		add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			COMMAND ${CMAKE_ASM_NASM_COMPILER} -f elf ${ROUTINES}.asm -o ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		)
	elseif(BITNESS EQUAL 64)
		set(ROUTINES "routines-x86-64bit")
		add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			COMMAND ${CMAKE_ASM_NASM_COMPILER} -f elf64 ${ROUTINES}.asm -o ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		)
	endif()

	if(LIBCPUID_FOUND AND WITH_LIBCPUID)
		add_definitions(-DHAS_LIBCPUID=1)
	else(LIBCPUID_FOUND AND WITH_LIBCPUID)
		add_definitions(-DHAS_LIBCPUID=0)
	endif(LIBCPUID_FOUND AND WITH_LIBCPUID)

	add_library(bandwidth
		STATIC
		bandwidth.c
		BMP.c
		BMPGraphing.c
		font.c
		minifont.c
		libbandwidth.h
		${ROUTINES}.o
	)

	target_link_libraries(bandwidth)
	set(BANDWIDTH_VERSION ${PROJECT_VERSION} PARENT_SCOPE)

else(CMAKE_ASM_NASM_INFOMATION_LOADED)
	 set(BANDWIDTH_FOUND OFF PARENT_SCOPE)
endif(CMAKE_ASM_NASM_INFOMATION_LOADED)

=== src/dmidecode/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
set(LOCALVERSION "3.0.20160907")
if(${CMAKE_VERSION} VERSION_GREATER "2.9")
	cmake_policy(SET CMP0048 NEW)
	project(dmidecode
		VERSION ${LOCALVERSION}
		LANGUAGES C
	)
else(${CMAKE_VERSION} VERSION_GREATER "2.9")
	project(dmidecode)
	set(PROJECT_VERSION ${LOCALVERSION})
endif(${CMAKE_VERSION} VERSION_GREATER "2.9")

# Config (dmidecode)
set(DMIDECODE_DEBUG_FLAGS "-Wall -Wextra -Wuninitialized -Wno-shift-count-overflow")
set(CMAKE_C_FLAGS_DEBUG   "${CMAKE_C_FLAGS_DEBUG}   ${DMIDECODE_DEBUG_FLAGS}")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${DMIDECODE_DEBUG_FLAGS}")
message(STATUS "Using built-in ${PROJECT_NAME}, version ${PROJECT_VERSION}")


# Build (dmidecode)
add_library(dmidecode
	STATIC
	types.h
	util.c
	util.h
	dmiopt.h
	dmioem.c
	dmioem.h
	dmidecode.c
	dmidecode.h
	libdmi.h
)

target_link_libraries(dmidecode)
set(DMIDECODE_VERSION ${PROJECT_VERSION} PARENT_SCOPE)

## cpu-x 3.2.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,15 +1,9 @@
-cmake_minimum_required(VERSION 2.8)
-set(LOCALVERSION "3.1.3")
-if(${CMAKE_VERSION} VERSION_GREATER "2.9")
-	cmake_policy(SET CMP0048 NEW)
-	project(cpu-x
-		VERSION ${LOCALVERSION}
-		LANGUAGES C
-	)
-else(${CMAKE_VERSION} VERSION_GREATER "2.9")
-	project(cpu-x)
-	set(PROJECT_VERSION ${LOCALVERSION})
-endif(${CMAKE_VERSION} VERSION_GREATER "2.9")
+cmake_minimum_required(VERSION 3.0)
+cmake_policy(SET CMP0048 NEW)
+project(cpu-x
+	VERSION "3.2.4"
+	LANGUAGES C
+)
 
 
 ### DEFAULT CONFIG
@@ -34,12 +28,21 @@
 set(CMAKE_C_FLAGS         "${CMAKE_C_FLAGS} -Wno-deprecated-declarations ${CPU_X_FLAGS}")
 set(CMAKE_C_FLAGS_DEBUG   "${CMAKE_C_FLAGS_DEBUG}   ${CPU_X_DEBUG_FLAGS}")
 set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${CPU_X_DEBUG_FLAGS}")
+set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
+set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now")
+
+include(CheckCCompilerFlag)
+check_c_compiler_flag("-no-pie" HAS_NO_PIE)
+if(HAS_NO_PIE)
+	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -no-pie")
+endif(HAS_NO_PIE)
 
 # Options
 option(WITH_GTK           "Build support for GUI in GTK3+"                                    ON)
 option(WITH_NCURSES       "Build support for TUI in NCurses"                                  ON)
 option(WITH_GETTEXT       "Build support for internationalization"                            ON)
 option(WITH_LIBCURL       "Use Libcurl library"                                               ON)
+option(WITH_LIBJSONC      "Use Libjson-c library"                                             ON)
 option(WITH_LIBCPUID      "Use Libcpuid library"                                              ON)
 option(WITH_LIBPCI        "Use Libpci library"                                                ON)
 option(WITH_LIBPROCPS     "Use Libprocps library"                                             ON)
@@ -126,10 +129,15 @@
 ### HELPERS / SUBDIRECTORIES
 
 find_package(PkgConfig REQUIRED)
-find_package(Gettext)
-find_package(Intl)
-find_package(Threads)
-find_package(Backtrace)
+find_package(Threads REQUIRED)
+find_package(Backtrace REQUIRED)
+if(WITH_GETTEXT)
+	find_package(Gettext)
+	if(${CMAKE_VERSION} VERSION_GREATER "3.1")
+		find_package(Intl)
+	endif(${CMAKE_VERSION} VERSION_GREATER "3.1")
+endif(WITH_GETTEXT)
+include(CheckSymbolExists)
 add_subdirectory(po)
 add_subdirectory(src)
 add_subdirectory(data)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,6 @@
-cmake_minimum_required(VERSION 2.8)
-if(${CMAKE_VERSION} VERSION_GREATER "2.9")
-	cmake_policy(SET CMP0048 OLD)
-endif(${CMAKE_VERSION} VERSION_GREATER "2.9")
-project(data)
+project(data
+	LANGUAGES NONE
+)
 
 
 # Files needed by GTK GUI
@@ -22,8 +20,16 @@
 	install(FILES
 		cpu-x-gtk-3.12.ui
 		cpu-x-gtk-3.12.css
+		cpu-x-gtk-3.12-dark.css
 		cpu-x-gtk-3.20.css
+		cpu-x-gtk-3.20-dark.css
 		DESTINATION ${CPU_X_DATA_DIRECTORY}/
+	)
+
+	# AppData metainfo file
+	install(FILES
+		cpu-x.appdata.xml
+		DESTINATION ${CMAKE_INSTALL_FULL_DATADIR}/metainfo/
 	)
 
 	# Install launchers

=== po/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,6 @@
-cmake_minimum_required(VERSION 2.8)
-if(${CMAKE_VERSION} VERSION_GREATER "2.9")
-	cmake_policy(SET CMP0048 OLD)
-endif(${CMAKE_VERSION} VERSION_GREATER "2.9")
-project(po)
+project(po
+	LANGUAGES NONE
+)
 
 # Config (po)
 set(absPotFile "${CMAKE_SOURCE_DIR}/po/cpu-x.pot")
@@ -75,7 +73,7 @@
 		# Convert .gmo files in a C header file
 		add_custom_target(convertgmo ALL)
 		set(vars)
-		set(moHeader "${CMAKE_SOURCE_DIR}/po/mo.h")
+		set(moHeader "${CMAKE_BINARY_DIR}/po/mo.h")
 		add_custom_command(TARGET convertgmo
 			COMMAND ${CMAKE_COMMAND} -E remove ${moHeader}
 		)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,3 @@
-cmake_minimum_required(VERSION 2.8)
-if(${CMAKE_VERSION} VERSION_GREATER "2.9")
-	cmake_policy(SET CMP0048 OLD)
-endif(${CMAKE_VERSION} VERSION_GREATER "2.9")
-project(binary)
-
-
 ### FIND NEEDED LIBRAIRIES
 
 # GTK3+
@@ -16,11 +9,12 @@
 		link_directories(${GTK3_LIBRARY_DIRS})
 		add_definitions(${GTK3_CFLAGS_OTHER})
 		if(PORTABLE_BINARY)
-			execute_process(COMMAND glib-compile-resources --target=${CMAKE_SOURCE_DIR}/src/gtk-resources.c --generate-source cpu-x.gresource.xml
-					COMMAND	glib-compile-resources --target=${CMAKE_SOURCE_DIR}/src/gtk-resources.h --generate-header cpu-x.gresource.xml
+			execute_process(COMMAND glib-compile-resources --target=${CMAKE_BINARY_DIR}/src/gtk_resources.c --generate-source cpu-x.gresource.xml
+					COMMAND	glib-compile-resources --target=${CMAKE_BINARY_DIR}/src/gtk_resources.h --generate-header cpu-x.gresource.xml
 					WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/data
 			)
-			set(GRESOURCES "gtk-resources.c")
+			set(GRESOURCES "gtk_resources.c")
+			include_directories(${CMAKE_BINARY_DIR}/src)
 		endif(PORTABLE_BINARY)
 		add_library(gui_gtk
 			gui_gtk.c
@@ -37,7 +31,7 @@
 
 # NCurses
 if(WITH_NCURSES)
-	pkg_check_modules(NCURSES ncurses)
+	pkg_check_modules(NCURSES ncursesw)
 	if(NCURSES_FOUND)
 		include_directories(${NCURSES_INCLUDE_DIRS})
 		link_directories(${NCURSES_LIBRARY_DIRS})
@@ -45,8 +39,8 @@
 			tui_ncurses.c
 			tui_ncurses.h
 		)
-		add_embedded_library(NCURSES_LIBRARIES "-l:libncursesw.a")
-		add_embedded_library_others(NCURSES_LIBRARIES "${NCURSES_LIBRARIES} -l:libtinfo.a")
+		add_embedded_library_linux(NCURSES_LIBRARIES "-l:libncursesw.a")
+		add_embedded_library_others(NCURSES_LIBRARIES "${NCURSES_LIBRARIES} -l:libncursesw.a -l:libtinfo.a")
 		set(NCURSES_LIBRARIES "tui_ncurses" ${NCURSES_LIBRARIES})
 	endif(NCURSES_FOUND)
 endif(WITH_NCURSES)
@@ -54,6 +48,7 @@
 # Gettext
 if(Intl_FOUND)
 	add_embedded_library_others(Intl_LIBRARIES "-l:libintl.a")
+	include_directories(${CMAKE_BINARY_DIR}/po)
 endif(Intl_FOUND)
 
 # Libcurl
@@ -64,9 +59,21 @@
 		link_directories(${LIBCURL_LIBRARY_DIRS})
 		add_definitions(${LIBCURL_CFLAGS_OTHER})
 		add_embedded_library(LIBCURL_LIBRARIES "-l:libcurl.a")
-		add_embedded_library_linux(LIBCURL_LIBRARIES "${LIBCURL_LIBRARIES} -l:libssl.a -l:libcrypto.a -lz -ldl")
+		add_embedded_library_linux(LIBCURL_LIBRARIES "${LIBCURL_LIBRARIES} -l:libssl.a -l:libcrypto.a -lz -ldl -lgssapi_krb5")
+		add_embedded_library_others(LIBCURL_LIBRARIES "${LIBCURL_LIBRARIES} -l:libz.a")
 	endif(LIBCURL_FOUND)
 endif(WITH_LIBCURL)
+
+# Libjson-c
+if(WITH_LIBJSONC)
+	pkg_check_modules(LIBJSONC json-c)
+	if(LIBJSONC_FOUND)
+		include_directories(${LIBJSONC_INCLUDE_DIRS})
+		link_directories(${LIBJSONC_LIBRARY_DIRS})
+		add_definitions(${LIBJSONC_CFLAGS_OTHER})
+		add_embedded_library(LIBJSONC_LIBRARIES "-l:libjson-c.a")
+	endif(LIBJSONC_FOUND)
+endif(WITH_LIBJSONC)
 
 # Libarchive
 if(PORTABLE_BINARY)
@@ -76,18 +83,24 @@
 		link_directories(${LIBARCHIVE_LIBRARY_DIRS})
 		add_definitions(${LIBARCHIVE_CFLAGS_OTHER})
 		add_embedded_library(LIBARCHIVE_LIBRARIES "-l:libarchive.a")
+		add_embedded_library_linux(LIBARCHIVE_LIBRARIES "${LIBARCHIVE_LIBRARIES} -ldl")
 		add_embedded_library_others(LIBARCHIVE_LIBRARIES "${LIBARCHIVE_LIBRARIES} -l:libssl.a -l:libcrypto.a -l:libgssapi.a -l:libbz2.a")
 	endif(LIBARCHIVE_FOUND)
 endif(PORTABLE_BINARY)
 
 # Libcpuid
 if(WITH_LIBCPUID)
-	pkg_check_modules(LIBCPUID libcpuid>=0.3.0)
+	pkg_check_modules(LIBCPUID libcpuid>=0.4.0)
 	if(LIBCPUID_FOUND)
 		include_directories(${LIBCPUID_INCLUDE_DIRS})
 		link_directories(${LIBCPUID_LIBRARY_DIRS})
 		add_definitions(${LIBCPUID_CFLAGS_OTHER})
 		add_embedded_library(LIBCPUID_LIBRARIES "-l:libcpuid.a")
+		set(CMAKE_REQUIRED_LIBRARIES ${LIBCPUID_LIBRARIES})
+		check_symbol_exists(msr_serialize_raw_data "libcpuid/libcpuid.h" HAVE_MSR_SERIALIZE_RAW_DATA)
+		if(HAVE_MSR_SERIALIZE_RAW_DATA)
+			add_definitions(-DHAVE_MSR_SERIALIZE_RAW_DATA)
+		endif(HAVE_MSR_SERIALIZE_RAW_DATA)
 	endif(LIBCPUID_FOUND)
 endif(WITH_LIBCPUID)
 
@@ -100,7 +113,7 @@
 		add_definitions(${LIBPCI_CFLAGS_OTHER})
 		add_embedded_library(LIBPCI_LIBRARIES "-l:libpci.a")
 		add_embedded_library_linux(LIBPCI_LIBRARIES "${LIBPCI_LIBRARIES} -lresolv -ludev")
-		add_embedded_library_others(LIBPCI_LIBRARIES "${LIBPCI_LIBRARIES} -lz")
+		add_embedded_library_others(LIBPCI_LIBRARIES "${LIBPCI_LIBRARIES} -l:libz.a")
 	endif(LIBPCI_FOUND)
 endif(WITH_LIBPCI)
 
@@ -158,6 +171,7 @@
 # Other libraries
 print_config("GETTEXT"             0                        GETTEXT_FOUND     WITH_GETTEXT)
 print_config("LIBCURL"             "${LIBCURL_VERSION}"     LIBCURL_FOUND     WITH_LIBCURL)
+print_config("LIBJSONC"            "${LIBJSONC_VERSION}"    LIBJSONC_FOUND    WITH_LIBJSONC)
 print_config("LIBCPUID"            "${LIBCPUID_VERSION}"    LIBCPUID_FOUND    WITH_LIBCPUID)
 print_config("LIBPCI"              "${LIBPCI_VERSION}"      LIBPCI_FOUND      WITH_LIBPCI)
 if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND NOT FORCE_LIBSTATGRAB)
@@ -221,7 +235,10 @@
 
 # Various definitions
 add_definitions(-DPRGVER="${PROJECT_VERSION}" -DCC="${CMAKE_C_COMPILER_ID}" -DHAS_LIBSYSTEM="${LIBSYSTEM}")
-add_definitions(-DGETTEXT_PACKAGE="${CMAKE_PROJECT_NAME}" -DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}")
+add_definitions(-DGETTEXT_PACKAGE="${CMAKE_PROJECT_NAME}" -DLOCALEDIR="${CMAKE_INSTALL_FULL_LOCALEDIR}" -DTERMINFODIR="/lib/terminfo")
+
+# Various libraries
+add_embedded_library_others(OTHER_LIBRARIES "-lelf -l:libnghttp2.a")
 
 # Link libraries
 target_link_libraries(cpu-x
@@ -233,6 +250,7 @@
 	${GTK3_LIBRARIES}
 	${NCURSES_LIBRARIES}
 	${LIBCURL_LIBRARIES}
+	${LIBJSONC_LIBRARIES}
 	${LIBARCHIVE_LIBRARIES}
 	${LIBCPUID_LIBRARIES}
 	${LIBPCI_LIBRARIES}
@@ -240,6 +258,7 @@
 	${LIBSTATGRAB_LIBRARIES}
 	${DMIDECODE_LIBRARIES}
 	${BANDWIDTH_LIBRARIES}
+	${OTHER_LIBRARIES}
 )

=== src/bandwidth/CMakeLists.txt ===
project(bandwidth
	VERSION "1.5.1"
	LANGUAGES C
)

# Config (bandwidth)
set(BANDWIDTH_DEBUG_FLAGS "-Wall -Wextra -Wuninitialized -Wno-strict-prototypes -Wno-unused-parameter -Wno-sign-compare -Wno-format-security")
set(CMAKE_C_FLAGS_DEBUG	  "${CMAKE_C_FLAGS_DEBUG}   ${BANDWIDTH_DEBUG_FLAGS}")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${BANDWIDTH_DEBUG_FLAGS}")

find_program(NASM_FOUND nasm)
if(NASM_FOUND)
	enable_language(ASM_NASM)
endif(NASM_FOUND)
if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
	set(NASM_FLAGS_DEBUG "-gdwarf")
endif(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")

# Build (bandwidth)
if(CMAKE_ASM_NASM_INFOMATION_LOADED)
	set(BANDWIDTH_FOUND ON PARENT_SCOPE)
	message(STATUS "Using built-in ${PROJECT_NAME}, version ${PROJECT_VERSION}")


	if(BITNESS EQUAL 32)
		set(ROUTINES "routines-x86-32bit")
		add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			COMMAND ${CMAKE_ASM_NASM_COMPILER} ${NASM_FLAGS_DEBUG} -f elf ${ROUTINES}.asm -o ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		)
	elseif(BITNESS EQUAL 64)
		set(ROUTINES "routines-x86-64bit")
		add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			COMMAND ${CMAKE_ASM_NASM_COMPILER} ${NASM_FLAGS_DEBUG} -f elf64 ${ROUTINES}.asm -o ${CMAKE_CURRENT_BINARY_DIR}/${ROUTINES}.o
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		)
	endif()

	if(LIBCPUID_FOUND AND WITH_LIBCPUID)
		add_definitions(-DHAS_LIBCPUID=1)
	else(LIBCPUID_FOUND AND WITH_LIBCPUID)
		add_definitions(-DHAS_LIBCPUID=0)
	endif(LIBCPUID_FOUND AND WITH_LIBCPUID)

	add_library(bandwidth
		STATIC
		BMP.c
		BMPGraphing.c
		font.c
		main.c
		minifont.c
		libbandwidth.h
		${ROUTINES}.o
	)

	target_link_libraries(bandwidth)
	set(BANDWIDTH_VERSION ${PROJECT_VERSION} PARENT_SCOPE)

else(CMAKE_ASM_NASM_INFOMATION_LOADED)
	 set(BANDWIDTH_FOUND OFF PARENT_SCOPE)
endif(CMAKE_ASM_NASM_INFOMATION_LOADED)

=== src/dmidecode/CMakeLists.txt ===
project(dmidecode
	VERSION "3.1.20180620"
	LANGUAGES C
)

# Config (dmidecode)
set(DMIDECODE_DEBUG_FLAGS "-Wall -Wextra -Wuninitialized -Wno-shift-count-overflow")
set(CMAKE_C_FLAGS_DEBUG   "${CMAKE_C_FLAGS_DEBUG}   ${DMIDECODE_DEBUG_FLAGS}")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${DMIDECODE_DEBUG_FLAGS}")
message(STATUS "Using built-in ${PROJECT_NAME}, version ${PROJECT_VERSION}")


# Build (dmidecode)
add_definitions(-DVERSION="${PROJECT_VERSION}")
add_library(dmidecode
	STATIC
	types.h
	util.c
	util.h
	dmiopt.h
	dmioem.c
	dmioem.h
	dmidecode.c
	dmidecode.h
	libdmi.h
)

target_link_libraries(dmidecode)
set(DMIDECODE_VERSION ${PROJECT_VERSION} PARENT_SCOPE)

=== debian/changelog ===
cpu-x (3.2.4-3build2) focal; urgency=medium

  * No-change rebuild against libprocps8

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 27 Feb 2020 07:20:06 +0000

cpu-x (3.2.4-3build1) focal; urgency=medium

  * No-change rebuild against libprocps8

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 27 Feb 2020 00:25:58 +0000

cpu-x (3.2.4-3) unstable; urgency=medium

  * debian/control:
    + Limit builds of cpu-x to amd64 and i386. (Closes: #949607).
    + Bump Standards-Version: to 4.5.0. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 17 Feb 2020 16:59:54 +0100

cpu-x (3.2.4-2) unstable; urgency=medium

  * No-change source-only upload.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 24 Nov 2019 14:01:02 +0100

cpu-x (3.2.4-1) unstable; urgency=medium

  * Initial upload to Debian. (Closes: #941014).

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 01 Oct 2019 14:10:58 +0200

=== debian/control ===
Source: cpu-x
Section: x11
Priority: optional
Maintainer: Martin Wimpress <martin.wimpress@ubuntu.com>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: debhelper-compat (= 12),
               cmake (>= 3),
               gettext,
               libcpuid-dev [amd64 i386],
               libgtk-3-dev (>= 3.12),
               libcurl4-gnutls-dev,
               libjson-c-dev,
               libncurses-dev,
               libpci-dev,
               libprocps-dev,
               libstatgrab-dev,
               nasm,
               pkg-config,
               procps,
Standards-Version: 4.5.0
Homepage: https://github.com/X0rg/CPU-X
Vcs-Git: https://salsa.debian.org/debian/cpu-x.git
Vcs-Browser: https://salsa.debian.org/debian/cpu-x
Rules-Requires-Root: no

Package: cpu-x
Architecture: amd64 i386
Depends: ${shlibs:Depends},
         ${misc:Depends},
         procps,
Description: Tool that gathers information on CPU, motherboard and more
 CPU-X is similar to CPU-Z (for MS Windows). It can be used in graphical
 mode by using GTK or in text-based mode by using NCurses. A dump mode is
 present from the command line.

=== debian/rules ===
#!/usr/bin/make -f

NULL=

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..

=== debian/watch ===
version=3
opts=filenamemangle=s/.*\/v?([\d\.-]+)\.tar\.gz/cpu-x-$1.tar.gz/ \
https://github.com/X0rg/CPU-X/tags .*/archive/v?([\d\.]+).tar.gz

## cpu-x 3.2.4+17.1

=== debian/changelog ===
cpu-x (3.2.4+17.1-1~mx19+1) mx; urgency=medium

  * Rebuild for MX 19.

 -- ”SwampRabbit” <maintainer@mepiscommunity.org>  Tue, 24 Sep 2019 01:38:44 -0400

cpu-x (3.2.4+17.1) stable; urgency=medium

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Mon, 11 Feb 2019 09:58:20 +0000

cpu-x (2.1.1-1) stable; urgency=medium

  * Initial release.

 -- Xorg <xorg@no-mail.com>  Sun, 13 Sep 2015 15:01:43 +0000

=== debian/control ===
Source: cpu-x
Section: Utilities
Priority: optional
Maintainer: SwampRabbit <maintainer@mepiscommunity.org>
XSBC-Original-Maintainer: Xorg <xorg@no-mail.com>
Build-Depends: debhelper (>= 4.1.16), cmake, gcc, nasm, gettext, libgtk-3-dev, libncursesw5-dev | libncursesw6-dev, libcurl4-openssl-dev, libjson-c-dev, libcpuid14-dev, libpci-dev, libprocps-dev

Package: cpu-x
Architecture: i386 amd64
Depends: libgtk-3-0, libncursesw5 | libncurses6, libcurl3 | libcurl4, libjson-c2 | libjson-c3, libcpuid14, libprocps3 | libprocps4 | libprocps6 | libprocps7, libpci3
Description: CPU-X is a Free software that gathers information on CPU, motherboard and more.
  CPU-X is similar to CPU-Z (Windows), but CPU-X is a Free and Open Source software designed for GNU/Linux; also, it works on *BSD.
  This software is written in C and built with CMake tool.
  It can be used in graphical mode by using GTK or in text-based mode by using NCurses. A dump mode is present from command line.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

#Packagname
plib_bin=cpu-x

# main packaging script based on dh7 syntax
%:
	dh $@ --parallel

# debmake generated override targets
# This is example for Cmake (See http://bugs.debian.org/641051 )
override_dh_auto_configure:
	cmake -DCMAKE_BUILD_TYPE=Release -DCMAKE_INSTALL_PREFIX=/usr .
override_dh_shlibdeps:
	dh_shlibdeps -- -xvirtualbox-guest-x11 --ignore-missing-info
